package kaka.cakelight.mode;

import kaka.cakelight.Color;
import kaka.cakelight.Configuration;
import kaka.cakelight.LedFrame;

public class SingleColorMode extends Mode {
    private Color color;
    private LedFrame frame;

    public SingleColorMode(Color c) {
        color = c;
    }

    private void colorizeFrame() {
        frame.fillColor(color);
        updateWithFrame(frame);
    }

    @Override
    public void enter(Configuration config) {
        frame = LedFrame.from(config);
        colorizeFrame();
    }

    @Override
    public void pause() {
    }

    @Override
    public void resume() {
        colorizeFrame();
    }

    @Override
    public void exit() {
    }
}
